---
title: ServiceWorkerMessageEvent.ServiceWorkerMessageEvent()
slug: Web/API/ServiceWorkerMessageEvent/ServiceWorkerMessageEvent
tags:
  - API
  - Constructor
  - Deprecated
  - Experimental
  - Reference
  - Service Workers
  - ServiceWorkerMessageEvent
---
<p>{{APIRef("Service Workers API")}}{{deprecated_header}}</p>

<div class="warning">
<p><strong>Important</strong>: In modern browsers, this property has been deprecated. Service worker messages will now use the {{domxref("MessageEvent")}} interface, for consistency with other web messaging features.</p>
</div>

<p>The <strong><code>ServiceWorkerMessageEvent()</code></strong> constructor creates a new {{domxref("ServiceWorkerMessageEvent")}} object instance.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var mySWME = new ServiceWorkerMessageEvent(type, init);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>type</dt>
 <dd>A {{domxref("DOMString")}} that defines the type of the message event being created.</dd>
 <dt>init {{optional_inline}}</dt>
 <dd>An initialisation object, which should contain the following parameters:
 <ul>
  <li><code>data</code>: The event's data — this can be any type.</li>
  <li><code>origin</code>: A {{domxref("DOMString")}} that defines the origin of the corresponding service worker's environment settings object.</li>
  <li><code>lastEventId</code>: A {{domxref("DOMString")}} that defines the last event ID of the event source.</li>
  <li><code>source</code>: The {{domxref("ServiceWorker")}} or {{domxref("MessagePort")}} that sent the message.</li>
  <li><code>ports</code>: An array containing the {{domxref("MessagePort")}} objects connected to the channel sending the message.</li>
 </ul>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var init = {
             data : 'hello message',
             source : MessagePortReference,
             ports : MessagePortListReference
           }

var mySWME = new ServiceWorkerMessageEvent('message', init);</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ServiceWorkerMessageEvent.ServiceWorkerMessageEvent")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging</a></li>
</ul>
